<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>

<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="flowRequestContext" type="org.springframework.webflow.execution.RequestContext"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="currentForm" type="org.jahia.modules.formfactory.webflow.model.Form"--%>
<%--@elvariable id="snippets" type="org.jahia.modules.formfactory.model.SnippetsDefinition"--%>
<%--@elvariable id="actions" type="org.jahia.modules.formfactory.model.SnippetsDefinition"--%>
<%--@elvariable id="validationsData" type="java.lang.String"--%>
<%--@elvariable id="popovers" type="org.jahia.modules.formfactory.model.SnippetsDefinition"--%>

<template:addResources type="css" rel="stylesheet" resources="custom.css"/>
<template:addResources type="css" resources="jasny-bootstrap.fileinput.css"/>
<template:addResources type="css" resources="themes/style.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="admin-bootstrap.js"/>

<template:addResources type="javascript" resources="fcBuilderUtils.js"/>
<template:addResources type="javascript" resources="jquery-ui.min.js,jquery.blockUI.js,workInProgress.js"/>
<template:addResources type="javascript" resources="lib/bootbox.min.js"/>
<template:addResources type="javascript" resources="lib/underscore.js"/>
<template:addResources type="javascript" resources="lib/typeahead.js"/>
<template:addResources type="javascript" resources="lib/jasny-bootstrap.fileinput.js"/>
<template:addResources type="javascript" resources="lib/jstree.js"/>

<fmt:message key="fcnt_createEntry.button.backWithoutSaving" var="buttonBackWithoutSaving"/>
<fmt:message key="fcnt_createEntry.button.goWithoutSaving" var="buttonGoWithoutSaving"/>
<fmt:message key="fcnt_createEntry.button.saveAndBack" var="buttonSaveAndBack"/>
<fmt:message key="fcnt_createEntry.button.saveAndGo" var="buttonSaveAndGo"/>
<fmt:message key="fcnt_builder.error.doubleIDInStep" var="errorDoubleIDInStep"/>
<fmt:message key="fcnt_builder.error.errorEmptyKey" var="errorEmptyKey"/>
<fmt:message key="fcnt_builder.help.helpFileSize" var="helpFileSize"/>
<fmt:message key="fcnt_createEntry.label.repeatedID" var="labelRepeatedID"/>
<fmt:message key="fcnt_createEntry.label.repeatedIDPosition" var="labelRepeatedIDPosition"/>
<fmt:message key="fcnt_builder.modal.backToLibrary" var="modalBackToLibrary"/>
<fmt:message key="fcnt_builder.modal.clearFormConfirmation" var="modalClearFormConfirmation"/>
<fmt:message key="fcnt_builder.modal.deleteFormStepConfirmation" var="modalDeleteFormStepConfirmation"/>
<fmt:message key="fcnt_builder.modal.errorWhenSavingFormNoAction" var="modalErrorWhenSavingFormNoAction"/>
<fmt:message key="fcnt_builder.modal.goToMetaDataEditor" var="modalGoToMetaDataEditor"/>
<fmt:message key="fcnt_builder.title.clearFormConfirmation" var="titleClearFormConfirmation"/>
<fmt:message key="fcnt_builder.title.deleteFormStepConfirmation" var="titleDeleteFormStepConfirmation"/>
<fmt:message key="fcnt_builder.title.errorWhenSavingForm" var="titleErrorWhenSavingForm"/>
<fmt:message key="fcnt_builder.title.quit" var="titleQuitFormCenterBuilder"/>
<fmt:message key="label.cancel" var="labelCancel"/>
<fmt:message key="label.next" var="labelNext"/>
<fmt:message key="label.no" var="labelNo"/>
<fmt:message key="label.yes" var="labelYes"/>
<fmt:message key="label.submit" var="labelSubmit"/>
<fmt:message key="label.workInProgressTitle" var="i18nWaiting"/>

<template:addResources type="inlinejavascript">
    <script>
        _.templateSettings = {
            interpolate: /\<\@\=(.+?)\@\>/gim,
            evaluate: /\<\@(.+?)\@\>/gim,
            escape: /\<\@\-(.+?)\@\>/gim
        };

        //Map with messages from resources bundle
        var jsVarMap = {
            buttonBackWithoutSaving: '${functions:escapeJavaScript(buttonBackWithoutSaving)}',
            buttonGoWithoutSaving: '${functions:escapeJavaScript(buttonGoWithoutSaving)}',
            buttonSaveAndBack: '${functions:escapeJavaScript(buttonSaveAndBack)}',
            buttonSaveAndGo: '${functions:escapeJavaScript(buttonSaveAndGo)}',
            errorDoubleIDInStep: '${functions:escapeJavaScript(errorDoubleIDInStep)}',
            errorEmptyKey: '${functions:escapeJavaScript(errorEmptyKey)}',
            helpFileSize: '${functions:escapeJavaScript(helpFileSize)}',
            labelCancel: '${functions:escapeJavaScript(labelCancel)}',
            labelNext: '${functions:escapeJavaScript(labelNext)}',
            labelNo: '${functions:escapeJavaScript(labelNo)}',
            labelRepeatedID: '${functions:escapeJavaScript(labelRepeatedID)}',
            labelRepeatedIDPosition: '${functions:escapeJavaScript(labelRepeatedIDPosition)}',
            labelSubmit: '${functions:escapeJavaScript(labelSubmit)}',
            labelYes: '${functions:escapeJavaScript(labelYes)}',
            modalBackToLibrary: '${functions:escapeJavaScript(modalBackToLibrary)}',
            modalClearFormConfirmation: '${functions:escapeJavaScript(modalClearFormConfirmation)}',
            modalDeleteFormStepConfirmation: '${functions:escapeJavaScript(modalDeleteFormStepConfirmation)}',
            modalErrorWhenSavingFormNoAction: '${functions:escapeJavaScript(modalErrorWhenSavingFormNoAction)}',
            modalGoToMetaDataEditor: '${functions:escapeJavaScript(modalGoToMetaDataEditor)}',
            titleClearFormConfirmation: '${functions:escapeJavaScript(titleClearFormConfirmation)}',
            titleDeleteFormStepConfirmation: '${functions:escapeJavaScript(titleDeleteFormStepConfirmation)}',
            titleErrorWhenSavingForm: '${functions:escapeJavaScript(titleErrorWhenSavingForm)}',
            titleQuitFormCenterBuilder: '${functions:escapeJavaScript(titleQuitFormCenterBuilder)}',
            i18nWaiting: '${functions:escapeJavaScript(i18nWaiting)}',
            context: '${url.context}'
        };

        //Loading libraries with Jahia URLs
        var baseUrlModule = '<c:url value="${url.currentModule}"/>';

        //Loading underscore templates
        var _popoverTemplates = ${popovers.templates};
        var _snippetTemplates = ${snippets.templates};
        var _snippetData = ${snippets.data};
        var _actionTemplates = ${actions.templates};
        var _actionData = ${actions.data};
        var _validationsData = ${validationsData};

        //Getting steps content from Webflow
        var displayedFormJcrId = "${functions:escapeJavaScript(currentForm.jcrId)}";
        var displayedFormName = "${functions:escapeJavaScript(currentForm.formName)}";
        <%--var formWithoutModification = ${formFactoryModel.displayedFormJSON};--%>
        var formJson = ${currentForm.json};
        var stepsTable = formJson.formSteps;
        var stepAction = formJson.formStepAction;
        var currentStep = ${currentForm.currentStep};
        var blockInfoPopupOnSectionChange = ${currentForm.hasNotBeenModified};
        // typeahead
        var pageFinderSource = new Bloodhound({
            datumTokenizer: Bloodhound.tokenizers.obj.whitespace('name'),
            queryTokenizer: Bloodhound.tokenizers.whitespace,
            remote: {
                url : '<c:url value="/modules/api/jcr/v1/default/${currentResource.locale}/query?noLinks"/>',
                wildcard: '___QUERY',
                replace : function (url, query) {
                    this.ajax.data = JSON.stringify({
                        limit     : 10,
                        queryName : 'formFactoryPageSearch',
                        parameters: ['${renderContext.site.path}', '%' + query.toLowerCase() + '%']
                    });
                    return url + "#" + query.toLowerCase();
                },
                cacheKey: 'pageFinder',
                filter: function (list) {
                    return _.map(list, function (page) {
                        return {
                            "name": page.name,
                            "value": page.id
                        };
                    });
                },
                ajax    : {
                    type       : 'POST',
                    contentType: 'application/json',
                    dataType   : 'json',
                    processData: false
                }
            }
        });
        pageFinderSource.initialize();
        var pageFinderTTAdapter = function () {
            return pageFinderSource.ttAdapter();
        };

        // Template to display if double in ID
        var modalTemplate = _.template('<span class="text-error">' + jsVarMap.labelRepeatedID.toUpperCase() + ' !</span><br />' +
                '<table class="table table-striped table-hover">' +
                '<thead>' +
                '<tr>' +
                '<th>' + jsVarMap.labelRepeatedID + '</th>' +
                '<th>' + jsVarMap.labelRepeatedIDPosition + '</th>' +
                '</tr>' +
                '</thead>' +
                '<tbody>' +
                '<@ for (var currentID in inputId) { @>' +
                '<tr>' +
                '<td><@= currentID @></td>' +
                '<td>' +
                '<@ _.each(inputId[currentID], function (k, v){ @>' +
                '<span class="badge"><@= v @></span> : ' +
                '<@= _.values(k) @><br />' +
                '<@ }); @>' +
                '</td>' +
                '</tr>' +
                '<@ } @>' +
                '</tbody>' +
                '</table>');

        var API_URL_START = "${url.server}${url.context}/modules/api/jcr/v1/default/${renderContext.mainResourceLocale}/nodes/";
        var rootNode = "${renderContext.site.home.identifier}";

        $(document).ready(function () {

            //Saving step and cloning the form
            $('.tabView a').on('click', function (e) {
                e.preventDefault();
                $(".minus-step").hide();
                $(this).find(".minus-step").show();
                if ($(this).data("step") != undefined) {
                    var newStep = $(this).data("step");

                    saveAndLoadFormInSteps(newStep);
                    if ($("#actions_tabLi").hasClass("active")) {
                        $("#actions_tabLi").removeClass("active");
                        $("#actions").removeClass("active");
                        $("#input_tabLi").addClass("active");
                        $("#input").addClass("active");
                    }
                } else {
                    var newStep = "stepAction";

                    saveAndLoadFormInSteps(newStep);
                    if (!$("#actions_tabLi").hasClass("active")) {
                        $("#formFactoryComponentsTabs li").removeClass("active");
                        $(".tab-pane").removeClass("active");
                        $("#actions_tabLi").addClass("active");
                        $("#actions").addClass("active");
                    }
                }
            });

            // CSS overwrite
            $('.tab-content').css("background", "transparent");
            $('.tab-content').css("border-style", "none");
            $('.tab-content').css("padding", "15px 0px");

        });
    </script>
    <script data-main="<c:url value='${url.currentModule}/javascript/main.js'/>"
            src="<c:url value='${url.currentModule}/javascript/lib/require.js'/>"></script>
</template:addResources>
<jcr:sql var="popovers" sql="select * from [fcmix:popover] as pop where isdescendantnode('/modules')"/>
<c:forEach var="popover" items="${popovers.nodes}">
    <template:addCacheDependency node="${popover}"/>
    <template:module node="${popover}" editable="false" templateType="html" view="resources"/>
</c:forEach>

<div class="clearfix">
    <h1 class="pull-left"><fmt:message key="fcnt_builder"/></h1>
    <div class="pull-right">
        <img alt="" src="<c:url value="${url.currentModule}/img/form-factory.png"/>">
    </div>
</div>

<div class="row-fluid">
    <div class="span6">
        <div class="btn-group">
            <button id="btnBackToLibrary" type="button" class="btn"
                    onclick="bbChangeSection('Library')">
                <i class="icon-home"></i>
                <fmt:message key="fcnt_createEntry.button.backToLibrary"/>
            </button>
            <c:if test="${not empty currentForm.jcrId}">
                <button id="btnGoToMetaDataEditor" type="button" class="btn" onclick="bbChangeSection('Builder')">
                    <fmt:message key="fcnt_createEntry.button.goToMetaDataEditor"/>
                    <i class="icon-arrow-right"></i>
                </button>
            </c:if>
        </div>
    </div>
    <div class="span6">
        <div class="btn-group pull-right">
            <button id="btnSaveForm" type="button" class="btn btn-primary"
                    onclick="submitCreatedForm()">
                <i class="icon-check icon-white"></i>
                <fmt:message key="fcnt_builder.button.saveForm"/>
            </button>
            <c:if test="${not empty currentForm.jcrId}">
                <button id="btnResetForm" type="button" class="btn btn-danger"
                        onclick="bbResetForm()" >
                    <i class="icon-repeat icon-white"></i>
                    <fmt:message key="fcnt_builder.button.clearForm"/>
                </button>
            </c:if>
        </div>
    </div>
</div>

<div class="box-1">
    <div class="row-fluid">
        <!-- Components -->
        <div class="span6">
            <h2><fmt:message key="fcnt_builder.title.components"/></h2>

            <div class="clearfix">
                <ul class="nav nav-tabs" id="formFactoryComponentsTabs">
                    <!-- Tab nav -->
                </ul>
                <form class="form-horizontal" id="formFactoryComponents">
                    <fieldset>
                        <div id="components-tab-content" class="tab-content">
                            <!-- Tabs of snippets go here -->
                        </div>
                    </fieldset>
                </form>
            </div>
        </div>
        <!-- /Components -->
        <div class="span6">
            <div class="row-fluid">
                <h2>${currentForm.formName}</h2>
                <ul class="nav nav-tabs" id="tabView">
                    <c:forEach items="${currentForm.formSteps}" var="step" varStatus="counter">
                        <li id="step${step.stepNumber}"
                            class="tabView <c:if test="${step.stepNumber eq currentForm.currentStep}">active</c:if>"
                            style="padding: 0;margin: 0">
                            <a href="#step${step.stepNumber}Content" data-toggle="tab" data-step="${step.stepNumber}">
                                <fmt:message key="fcnt_createEntry.label.step"/>&nbsp;${step.stepNumber+1}
                                <c:if test="${fn:length(currentForm.formSteps) gt 1}">
                                    <button type="button" class="btn-link minus-step"
                                            style="border-bottom-width: 0px; border-top-width: 0px; line-height: 14px;
                                            <c:if test='${step.stepNumber ne currentForm.currentStep}'> display: none;</c:if>"
                                            onclick="bbDeleteCurrentStep()">
                                        <i class="icon-remove-sign"></i>
                                    </button>
                                </c:if>
                            </a>
                        </li>
                    </c:forEach>
                    <li class="tabView" style="padding: 0;margin: 0">
                        <form:form name="formManagement" class="currentFormManagement" action="${flowExecutionUrl}"
                                   method="post"
                                   modelAttribute="currentForm" cssStyle="margin: 0;padding: 0">
                            <input id="eventInput" name="_eventId_" type="hidden"/>
                            <input type="hidden" id="formNewJson" name="formNewJson"/>
                            <input type="hidden" id="selectedForm" name="selectedForm" value="${currentForm.jcrId}"/>
                            <form:hidden path="currentStep"/>
                            <form:hidden path="formStepsNumber" id="formStepsNumber"/>
                            <a href="#" id="plusButton" onclick="stepPlus()">
                                <i class="icon-plus-sign" style="margin-top: 10px; margin-left: 10px"></i>
                            </a>
                        </form:form>
                    </li>
                    <li id="stepActionLi" class="tabView pull-right">
                        <a href="#stepActionContent" data-toggle="tab">
                            <span id="stepActionIndicator" class="badge
                            <c:choose>
                                <c:when test="${empty currentForm.formStepAction.stepActionContent}">
                                    badge-important
                                </c:when>
                                <c:otherwise>
                                    badge-success
                                </c:otherwise>
                            </c:choose>" style="padding: 1px 4px;">${fn:length(currentForm.formStepAction.stepActionContent)}</span>
                            <fmt:message key="fcnt_createEntry.label.step.actionsStep"/>
                        </a>
                    </li>
                </ul>
            </div>
            <div class="row-fluid">
                <div class="alert alert-info" style="margin-top: 15px;margin-bottom: 0px;">
                    <h4><fmt:message key="fcnt_builder.label.drag&DropHere"/></h4>
                </div>
                <div class="tab-content">
                    <div class="tab-pane active" id="step${currentForm.currentStep}Content">
                        <!-- Building Form. -->
                        <div id="formFactoryBuild">
                            <form id="formFactoryTarget" class="form-horizontal">
                            </form>
                        </div>
                        <!-- / Building Form. -->
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>