<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>

<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="flowRequestContext" type="org.springframework.webflow.execution.RequestContext"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="currentForm" type="org.jahia.modules.formfactory.webflow.model.Form"--%>

<template:addResources type="css" resources="languageSwitchingLinks.css"/>
<template:addResources type="css" resources="admin-bootstrap.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="jquery-ui.min.js,jquery.blockUI.js,workInProgress.js"/>
<template:addResources type="javascript" resources="admin-bootstrap.js"/>
<template:addResources type="javascript" resources="fcMetaDataUtils.js"/>
<template:addResources type="javascript" resources="lib/bootbox.min.js"/>
<template:addResources type="javascript" resources="lib/underscore.js"/>

<fmt:message key="fcnt_createEntry.button.backWithoutSaving" var="buttonBackWithoutSaving"/>
<fmt:message key="fcnt_createEntry.button.goWithoutSaving" var="buttonGoWithoutSaving"/>
<fmt:message key="fcnt_createEntry.button.saveAndBack" var="buttonSaveAndBack"/>
<fmt:message key="fcnt_createEntry.button.saveAndGo" var="buttonSaveAndGo"/>
<fmt:message key="fcnt_createEntry.error.formNameImpossibleToCheck" var="errorFormNameImpossibleToCheck"/>
<fmt:message key="fcnt_metaData.modal.backToLibrary" var="modalBackToLibrary"/>
<fmt:message key="fcnt_metaData.modal.backToLibraryWithFormNewNameNotAvailable" var="modalBackToLibraryWithFormNewNameNotAvailable"/>
<fmt:message key="fcnt_metaData.modal.goToBuilder" var="modalGoToBuilder"/>
<fmt:message key="fcnt_metaData.modal.goToBuilderWithFormNewNameNotAvailable" var="modalGoToBuilderWithFormNewNameNotAvailable"/>
<fmt:message key="fcnt_metaData.modal.goToTranslator" var="modalGoToTranslator"/>
<fmt:message key="fcnt_metaData.modal.goToTranslatorWithFormNewNameNotAvailable" var="modalGoToTranslatorWithFormNewNameNotAvailable"/>
<fmt:message key="fcnt_metaData.modal.cancelModification" var="modalCancelModification"/>
<fmt:message key="fcnt_metaData.title.confirmCancelLastChanges" var="titleConfirmCancelLastChanges"/>
<fmt:message key="fcnt_metaData.title.quit" var="titleQuitFormCenterMetaDataEditor"/>
<fmt:message key="fcnt_metaData.label.tooltipAfterSubmissionText" var="tooltipAfterSubmissionText"/>
<fmt:message key="label.cancel" var="labelCancel"/>
<fmt:message key="label.ok" var="labelOK"/>
<fmt:message key="label.workInProgressTitle" var="i18nWaiting"/>

<template:addResources type="inlinejavascript">
    <script>
        //Map with messages from resources bundle
        var jsVarMap = {
            buttonBackWithoutSaving: '${functions:escapeJavaScript(buttonBackWithoutSaving)}',
            buttonGoWithoutSaving: '${functions:escapeJavaScript(buttonGoWithoutSaving)}',
            buttonSaveAndBack: '${functions:escapeJavaScript(buttonSaveAndBack)}',
            buttonSaveAndGo: '${functions:escapeJavaScript(buttonSaveAndGo)}',
            checkFormNameURL : '<c:url value="${url.base}${renderContext.mainResource.node.path}.checkFormNameAvailability.do"/>',
            errorFormNameImpossibleToCheck: '${functions:escapeJavaScript(errorFormNameImpossibleToCheck)}',
            i18nWaiting: '${functions:escapeJavaScript(i18nWaiting)}',
            labelCancel: '${functions:escapeJavaScript(labelCancel)}',
            labelOK: '${functions:escapeJavaScript(labelOK)}',
            modalBackToLibrary: '${functions:escapeJavaScript(modalBackToLibrary)}',
            modalBackToLibraryWithFormNewNameNotAvailable: '${functions:escapeJavaScript(modalBackToLibraryWithFormNewNameNotAvailable)}',
            modalGoToBuilder: '${functions:escapeJavaScript(modalGoToBuilder)}',
            modalGoToBuilderWithFormNewNameNotAvailable: '${functions:escapeJavaScript(modalGoToBuilderWithFormNewNameNotAvailable)}',
            modalGoToTranslator: '${functions:escapeJavaScript(modalGoToTranslator)}',
            modalGoToTranslatorWithFormNewNameNotAvailable: '${functions:escapeJavaScript(modalGoToTranslatorWithFormNewNameNotAvailable)}',
            modalCancelModification: '${functions:escapeJavaScript(modalCancelModification)}',
            titleConfirmCancelLastChanges: '${functions:escapeJavaScript(titleConfirmCancelLastChanges)}',
            newNameIsAvailable: true,
            originalName: '${functions:escapeJavaScript(currentForm.formName)}',
            originalCssClass: '${functions:escapeJavaScript(currentForm.cssClassName)}',
            originalDescription: '${functions:escapeJavaScript(currentForm.formDescription)}',
            originalAfterSubmissionText: '${functions:escapeJavaScript(currentForm.afterSubmissionText)}',
            siteName: '${functions:escapeJavaScript(renderContext.site.name)}',
            titleQuitFormCenterMetaDataEditor: '${functions:escapeJavaScript(titleQuitFormCenterMetaDataEditor)}',
            tooltipAfterSubmissionText: '${functions:escapeJavaScript(tooltipAfterSubmissionText)}'
        };

        $(document).ready(function () {
            var timeoutReference;
            $('#renameForm').keypress(function() {
                var _this = $(this);
                if (timeoutReference) clearTimeout(timeoutReference);
                timeoutReference = setTimeout(function() {
                    checkFormNameAvailableInJCR(_this.val(), '${currentForm.jcrId}');
                }, 1000);
            });

            $('#tooltipAfterSubmissionText').tooltip({
                title: jsVarMap.tooltipAfterSubmissionText,
                placement: "top",
                trigger: "hover"
            });

            $('.toggleMetaDataBtn').keypress(function() {
                if (timeoutReference) clearTimeout(timeoutReference);
                timeoutReference = setTimeout(function() {
                    toggleMetaDataButton();
                }, 500);
            });
        });
    </script>
</template:addResources>

<div class="clearfix">
    <h1 class="pull-left"><fmt:message key="fcnt_metaData"/></h1>
    <div class="pull-right">
        <img alt="" src="<c:url value="${url.currentModule}/img/form-factory.png"/>">
    </div>
</div>

<div class="row-fluid">
    <div class="btn-group">
        <button id="btnBackToLibrary" type="button" class="btn" onclick="bbChangeSection('Library')">
            <i class="icon-home"></i>
            <fmt:message key="fcnt_createEntry.button.backToLibrary"/>
        </button>
        <c:choose>
            <c:when test="${functions:toLocale(currentForm.buildingLang) eq renderContext.mainResourceLocale}">
                <button id="btnGoToBuilder" type="button" class="btn" onclick="bbChangeSection('Builder')">
                    <fmt:message key="fcnt_metaData.button.goToBuilder"/>
                    <i class="icon-arrow-right"></i>
                </button>
            </c:when>
            <c:otherwise>
                <button id="btnGoToTranslator" type="button" class="btn" onclick="bbChangeSection('Translator')">
                    <fmt:message key="fcnt_metaData.button.goToTranslator"/>
                    <i class="icon-arrow-right"></i>
                </button>
            </c:otherwise>
        </c:choose>
    </div>
</div>

<div class="row-fluid">
    <div class="span5 box-1">
        <div class="alert alert-info">
            <fmt:message key="fcnt_metaData.label.metaDataInformation"><fmt:param value="${functions:displayLocaleNameWith(currentResource.locale, renderContext.UILocale)}"/></fmt:message>
        </div>
        <form:form cssClass="form-horizontal" action="${flowExecutionUrl}" method="post"
                   modelAttribute="currentForm" id="currentFormMetaData">
            <input id="eventInput" name="_eventId_" type="hidden"/>

            <div class="control-group">
                <label class="control-label" for="renameForm"><fmt:message key="fcnt_createEntry.title.nameForm"/></label>
                <div class="controls">
                    <input id="renameForm" class="span8" name="renameForm" type="text" value="${fn:escapeXml(currentForm.formName)}"/>
                    <div class="hide text-error" id="error_renameFormAvailability"></div>
                </div>
            </div>

            <div class="control-group">
                <form:label cssClass="control-label" path="cssClassName"><fmt:message key="fcnt_metaData.label.formCssClassName"/></form:label>
                <div class="controls">
                    <form:input cssClass="toggleMetaDataBtn span8" path="cssClassName"/>
                    <div class="hide text-error" id="error_cssClass"><fmt:message key="fcnt_metaData.error.formCssClassName"/></div>
                </div>
            </div>

            <div class="control-group">
                <form:label cssClass="control-label" path="formDescription"><fmt:message key="fcnt_metaData.label.formDescription"/></form:label>
                <div class="controls">
                    <form:textarea cssClass="toggleMetaDataBtn span8" path="formDescription" rows="5"/>
                </div>
            </div>

            <div class="control-group">
                <form:label cssClass="control-label" path="afterSubmissionText"><fmt:message key="fcnt_metaData.label.formAfterSubmissionText"/>
                    <i class="icon-info-sign" id="tooltipAfterSubmissionText"></i>
                </form:label>
                <div class="controls">
                    <form:textarea cssClass="toggleMetaDataBtn span8" path="afterSubmissionText" rows="5"/>
                </div>
            </div>

            <div class="form-actions">
                <button id="btnSaveMetaData" type="button" class="btn btn-primary" onclick="saveMetaData()" disabled="disabled">
                    <fmt:message key="fcnt_metaData.button.saveMetaData"/>
                </button>
                <button id="btnCancelMetaData" type="button" class="btn" onclick="resetMetaData()" disabled="disabled">
                    <fmt:message key="label.cancel"/>
                </button>
            </div>
        </form:form>
    </div>

    <c:choose>
        <c:when test="${fn:length(currentForm.missingLanguagesAsLocale) gt 0}">
            <div class="span7 box-1">
                <div class="span7">
                    <div class="alert alert-info">
                        <i class="icon-info-sign"></i><fmt:message key="fcnt_metaData.info.translateInformation"/>
                    </div>
                    <form:form cssClass="form-horizontal" action="${flowExecutionUrl}" method="post"
                               modelAttribute="currentForm" id="currentFormTranslation">
                        <input id="currentFormTranslationEventInput" name="_eventId_" type="hidden"/>

                        <div class="control-group">
                            <label class="control-label" for="formTranslation"><fmt:message key="fcnt_metaData.label.availableLanguages"/></label>
                            <div class="controls">
                                <select class="span9" multiple="multiple" id="formTranslation" name="formTranslation" onchange="toggleTranslationButton()">
                                    <c:forEach items="${currentForm.missingLanguagesAsLocale}" var="lang">
                                        <option value="${lang}">${functions:displayLocaleNameWith(lang, renderContext.UILocale)}</option>
                                    </c:forEach>
                                </select>
                            </div>
                        </div>
                        <div class="form-actions">
                            <button id="btnSaveTranslation" type="button" class="btn btn-primary" onclick="addNewLanguages()" disabled="disabled">
                                <fmt:message key="label.copy"/>
                            </button>
                            <button id="btnCancelTranslation" type="button" class="btn" onclick="resetTranslation()" disabled="disabled">
                                <fmt:message key="label.cancel"/>
                            </button>
                        </div>
                    </form:form>
                </div>
                <div class="span5">
                    <div class="alert alert-info">
                        <fmt:message key="fcnt_metaData.label.languagesList"/>
                    </div>
                    <ul>
                        <c:forEach items="${currentForm.existingLanguagesAsLocale}" var="lang">
                            <li>
                                <span class="flag ${functions:getLanguageFlagCSSClass(lang)}">${functions:displayLocaleNameWith(lang, renderContext.UILocale)}</span>
                            </li>
                        </c:forEach>
                    </ul>
                </div>
            </div>
        </c:when>
        <c:otherwise>
            <div class="span3 box-1">
                <div class="alert alert-info">
                    <fmt:message key="fcnt_metaData.label.languagesList"/>
                </div>
                <ul>
                    <c:forEach items="${currentForm.existingLanguagesAsLocale}" var="lang">
                        <li>
                            <span class="flag ${functions:getLanguageFlagCSSClass(lang)}">${functions:displayLocaleNameWith(lang, renderContext.UILocale)}</span>
                        </li>
                    </c:forEach>
                </ul>
            </div>
        </c:otherwise>
    </c:choose>
</div>

