<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>

<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="flowRequestContext" type="org.springframework.webflow.execution.RequestContext"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="currentForm" type="org.jahia.modules.formfactory.webflow.model.Form"--%>
<%--@elvariable id="snippets" type="org.jahia.modules.formfactory.model.SnippetsDefinition"--%>
<%--@elvariable id="actions" type="org.jahia.modules.formfactory.model.SnippetsDefinition"--%>
<%--@elvariable id="validationsData" type="java.lang.String"--%>
<%--@elvariable id="popovers" type="org.jahia.modules.formfactory.model.SnippetsDefinition"--%>

<template:addResources type="css" rel="stylesheet" resources="custom.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="admin-bootstrap.js"/>

<template:addResources type="javascript" resources="fcTranslateUtils.js"/>
<template:addResources type="javascript" resources="jquery-ui.min.js,jquery.blockUI.js,workInProgress.js"/>
<template:addResources type="javascript" resources="lib/bootbox.min.js"/>
<template:addResources type="javascript" resources="lib/underscore.js"/>
<template:addResources type="javascript" resources="lib/typeahead.js"/>

<fmt:message key="fcnt_createEntry.button.backWithoutSaving" var="buttonBackWithoutSaving"/>
<fmt:message key="fcnt_createEntry.button.goWithoutSaving" var="buttonGoWithoutSaving"/>
<fmt:message key="fcnt_createEntry.button.saveAndBack" var="buttonSaveAndBack"/>
<fmt:message key="fcnt_createEntry.button.saveAndGo" var="buttonSaveAndGo"/>
<fmt:message key="fcnt_createEntry.label.repeatedID" var="labelRepeatedID"/>
<fmt:message key="fcnt_createEntry.label.repeatedIDPosition" var="labelRepeatedIDPosition"/>
<fmt:message key="fcnt_translate.modal.backToLibrary" var="modalBackToLibrary"/>
<fmt:message key="fcnt_translate.modal.goToMetaDataEditor" var="modalGoToMetaDataEditor"/>
<fmt:message key="fcnt_translate.title.quit" var="titleQuitFormCenterTranslator"/>
<fmt:message key="label.cancel" var="labelCancel"/>
<fmt:message key="label.next" var="labelNext"/>
<fmt:message key="label.no" var="labelNo"/>
<fmt:message key="label.yes" var="labelYes"/>
<fmt:message key="label.submit" var="labelSubmit"/>
<fmt:message key="label.workInProgressTitle" var="i18nWaiting"/>

<template:addResources type="inlinejavascript">
    <script>
        _.templateSettings = {
            interpolate: /\<\@\=(.+?)\@\>/gim,
            evaluate: /\<\@(.+?)\@\>/gim,
            escape: /\<\@\-(.+?)\@\>/gim
        };

        //Map with messages from resources bundle
        var jsVarMap = {
            buttonBackWithoutSaving: '${functions:escapeJavaScript(buttonBackWithoutSaving)}',
            buttonGoWithoutSaving: '${functions:escapeJavaScript(buttonGoWithoutSaving)}',
            buttonSaveAndBack: '${functions:escapeJavaScript(buttonSaveAndBack)}',
            buttonSaveAndGo: '${functions:escapeJavaScript(buttonSaveAndGo)}',
            labelCancel: '${functions:escapeJavaScript(labelCancel)}',
            labelNext: '${functions:escapeJavaScript(labelNext)}',
            labelNo: '${functions:escapeJavaScript(labelNo)}',
            labelRepeatedID: '${functions:escapeJavaScript(labelRepeatedID)}',
            labelRepeatedIDPosition: '${functions:escapeJavaScript(labelRepeatedIDPosition)}',
            labelSubmit: '${functions:escapeJavaScript(labelSubmit)}',
            labelYes: '${functions:escapeJavaScript(labelYes)}',
            modalBackToLibrary: '${functions:escapeJavaScript(modalBackToLibrary)}',
            modalGoToMetaDataEditor: '${functions:escapeJavaScript(modalGoToMetaDataEditor)}',
            titleQuitFormCenterTranslator: '${functions:escapeJavaScript(titleQuitFormCenterTranslator)}',
            i18nWaiting: '${functions:escapeJavaScript(i18nWaiting)}'
        };

        //Loading libraries with Jahia URLs
        var baseUrlModule = '<c:url value="${url.currentModule}"/>';

        //Loading underscore templates
        var _popoverTemplates = ${popovers.templates};
        var _snippetTemplates = ${snippets.templates};
        var _snippetData = ${snippets.data};
        var _actionTemplates = ${actions.templates};
        var _actionData = ${actions.data};
        var _validationsData = ${validationsData};

        //Getting steps content from Webflow
        var displayedFormJcrId = "${functions:escapeJavaScript(currentForm.jcrId)}";
        var displayedFormName = "${functions:escapeJavaScript(currentForm.formName)}";
        <%--var formWithoutModification = ${currentFormJSON};--%>
        var formJson = ${currentForm.json};
        var stepsTable = formJson.formSteps;
        var stepAction = formJson.formStepAction;
        var currentStep = ${currentForm.currentStep};
        var blockInfoPopupOnSectionChange = true;
        // typeahead
        var pageQuery = function() {
            return "select * from [jnt:page] as page where isdescendantnode(page,'${renderContext.site.path}') and localname(page) like '%___QUERY%'";
        };
        var prefetchQuery = function() {
            return "select * from [jnt:page] as page where isdescendantnode(page,'${renderContext.site.path}')";
        };
        var pageFinderSource = new Bloodhound({
            datumTokenizer: Bloodhound.tokenizers.obj.whitespace('name'),
            queryTokenizer: Bloodhound.tokenizers.whitespace,
            /*prefetch: {
                url: 'http://localhost:8080/cms/find/default/en?query=' + encodeURIComponent(prefetchQuery()),
                cacheKey: 'pageFinder',
                filter:function(list){
                        return _.map(list, function(page){
                        return {"name":page.node.nodename};
                    });
                }
            },*/
            remote: {
                url: '${url.server}${url.context}${url.find}' + '?query=' + encodeURIComponent(pageQuery()),
                wildcard: '___QUERY',
                cacheKey: 'pageFinder',
                filter:function(list){
                    return _.map(list, function(page){
                        return {
                            "name":page.node.nodename,
                            "value":page.node.path
                        };
                    });
                }
            }
        });
        pageFinderSource.initialize();
        var pageFinderTTAdapter = function(){
            return pageFinderSource.ttAdapter();
        };

        // Template to display if double in ID
        var modalTemplate = _.template('<span class="text-error">' + jsVarMap.labelRepeatedID.toUpperCase() + ' !</span><br />' +
                '<table class="table table-striped table-hover">' +
                '<thead>' +
                '<tr>' +
                '<th>' + jsVarMap.labelRepeatedID + '</th>' +
                '<th>' + jsVarMap.labelRepeatedIDPosition + '</th>' +
                '</tr>' +
                '</thead>' +
                '<tbody>' +
                '<@ for (var currentID in inputId) { @>' +
                '<tr>' +
                '<td><@= currentID @></td>' +
                '<td>' +
                '<@ _.each(inputId[currentID], function (k, v){ @>' +
                '<span class="badge"><@= v @></span> : ' +
                '<@= _.values(k) @><br />' +
                '<@ }); @>' +
                '</td>' +
                '</tr>' +
                '<@ } @>' +
                '</tbody>' +
                '</table>');

        $(document).ready(function () {
            //Saving step and cloning the form
            $('.tabView a').on('click', function (e) {
                e.preventDefault();
                if ($(this).data("step") != undefined) {
                    var newStep = $(this).data("step");

                    saveAndLoadFormInSteps(newStep);
                    if ($("#actions_tabLi").hasClass("active")) {
                        $("#actions_tabLi").removeClass("active");
                        $("#actions").removeClass("active");
                        $("#input_tabLi").addClass("active");
                        $("#input").addClass("active");
                    }
                } else {
                    var newStep ="stepAction";

                    saveAndLoadFormInSteps(newStep);
                    if (!$("#actions_tabLi").hasClass("active")) {
                        $("#formFactoryComponentsTabs li").removeClass("active");
                        $(".tab-pane").removeClass("active");
                        $("#actions_tabLi").addClass("active");
                        $("#actions").addClass("active");
                    }
                }
            });

            // CSS overwrite
            $('.tab-content').css("background", "transparent");
            $('.tab-content').css("border-style", "none");
            $('.tab-content').css("padding", "15px 0px");
        });
    </script>
    <script data-main="<c:url value='${url.currentModule}/javascript/main-translate.js'/>"
            src="<c:url value='${url.currentModule}/javascript/lib/require.js'/>"></script>
</template:addResources>

<div class="clearfix">
    <h1 class="pull-left"><fmt:message key="fcnt_translate"/></h1>
    <div class="pull-right">
        <img alt="" src="<c:url value="${url.currentModule}/img/form-factory.png"/>">
    </div>
</div>

<div class="row-fluid">
    <div class="span6">
        <div class="btn-group">
            <button id="btnBackToLibrary" type="button" class="btn" onclick="bbChangeSection('Library')">
                <i class="icon-home"></i>
                <fmt:message key="fcnt_createEntry.button.backToLibrary"/>
            </button>
            <button id="btnGoToMetaDataEditor" type="button" class="btn" onclick="bbChangeSection('Builder')">
                <fmt:message key="fcnt_createEntry.button.goToMetaDataEditor"/>
                <i class="icon-arrow-right"></i>
            </button>
        </div>
    </div>
    <div class="span6">
        <button id="btnSaveForm" type="button" class="btn btn-primary pull-right" onclick="submitTranslation()">
            <i class="icon-check icon-white"></i>
            <fmt:message key="fcnt_translate.button.saveTranslation"/>
        </button>
    </div>
</div>


<div class="row-fluid">
    <div class="span6 box-1">
        <div class="row-fluid">
            <h2>${currentForm.formName}</h2>
            <ul class="nav nav-tabs" id="tabView">
                <c:forEach items="${currentForm.formSteps}" var="step">
                    <li id="step${step.stepNumber}" class="tabView <c:if test="${step.stepNumber eq currentForm.currentStep}">active</c:if>">
                        <a href="#step${step.stepNumber}Content" data-toggle="tab" data-step="${step.stepNumber}">
                            <fmt:message key="fcnt_createEntry.label.step"/>&nbsp;${step.stepNumber+1}
                        </a>
                    </li>
                </c:forEach>
                <li id="stepActionLi" class="tabView pull-right">
                    <a href="#stepActionContent" data-toggle="tab">
                        <span id="stepActionIndicator" class="badge
                        <c:choose>
                            <c:when test="${empty currentForm.formStepAction.stepActionContent}">
                                badge-important
                            </c:when>
                            <c:otherwise>
                                badge-success
                            </c:otherwise>
                        </c:choose>">${fn:length(currentForm.formStepAction.stepActionContent)}</span>
                        <fmt:message key="fcnt_createEntry.label.step.actionsStep"/>
                    </a>
                </li>
            </ul>
        </div>
        <div class="row-fluid">
            <div class="tab-content">
                <div class="tab-pane active" id="step${currentForm.currentStep}Content">
                    <!-- Building Form. -->
                    <div id="formFactoryBuild">
                        <form id="formFactoryTarget" class="form-horizontal">
                        </form>
                    </div>
                    <!-- / Building Form. -->
                </div>
            </div>
        </div>
    </div>
</div>

<div class="hide">
    <form:form action="${flowExecutionUrl}" method="post" modelAttribute="currentForm" cssStyle="margin: 0;padding: 0">
        <input id="eventInput" name="_eventId_" type="hidden"/>
        <input type="hidden" id="formNewJson" name="formNewJson"/>
        <form:hidden path="currentStep"/>
        <form:hidden path="formStepsNumber" id="formStepsNumber"/>
    </form:form>
</div>