<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>

<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="flowRequestContext" type="org.springframework.webflow.execution.RequestContext"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<jcr:propertyInitializers var="countries" nodeType="fcnt:countryListDefinition" name="country"/>

<div class="control-group">
    <label class="control-label" for="<@= id @>">
        <@= label @>
    </label>
    <div class="controls">
        <select id="<@= id @>" name="<@= id @>" class="<@= inputsize @>" <@ if(validations != undefined && validations.required) { @> required="required" <@ } @> >
            <option value=""><@= placeholder @></option>
            <c:forEach items="${countries}" var="country">
                <option value='{"country":{"key":"${country.value.string}","name":"${country.displayName}"},"rendererName":"country"}'>${country.displayName}</option>
            </c:forEach>
        </select>
        <@ if(validations != undefined) { @>
            <span class="hide help-inline"></span>
        <@ } @>
        <@ if (helptext.length > 0) { @>
            <p class="help-block"><@= helptext @></p>
        <@ } @>
    </div>
</div>
