<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>

<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="flowRequestContext" type="org.springframework.webflow.execution.RequestContext"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<jcr:node path="${currentNode.path}/message" var="nodeRangeMessage"/>
<jcr:node path="${currentNode.path}/filetype" var="nodefiletype"/>
<jcr:node path="${currentNode.path}/filesize" var="nodefilesize"/>

<c:set var="fileType" value="${nodefiletype.properties['jsonValue'].string}"/>
<c:set var="fileSize" value="${nodefilesize.properties['jsonValue'].string}"/>
<c:set var="rangeMessage" value="${nodeRangeMessage.properties['jsonValue'].string}"/>

<c:if test="${(not empty fileType)}">
    {
        fn: function(value, blockname, model) {
            var selectedFiles;
            $("#formFactoryTarget :file").each(function(idx,elt){
                if($(elt).attr('id') == blockname){
                    selectedFiles = elt.files;
                }
            });
            if(selectedFiles != undefined) {
                var patterns = {
                    'all'  :'*.*',
                    'image':'image/.*',
                    'text' :'text/.*',
                    'audio':'audio/.*',
                    'video':'video/.*',
                    'pdf'  :'application/pdf',
                    'doc'  :'application/(pdf|*.word.*|.*openxmlformats-officedocument.*|.*opendocument.*|.*excel.*|.*powerpoint.*)'}
                var currentFile = selectedFiles[0];
                var fileType = _.findWhere(JSON.parse('${fileType}'),{selected:true}).value;
                if(currentFile != undefined && !currentFile.type.toLowerCase().match(patterns[fileType])) {
                <c:if test="${not empty rangeMessage}">
                return '${functions:escapeJavaScript(rangeMessage)}'
                </c:if>
                }
            }
        }
    }
</c:if>
<c:if test="${(not empty fileSize)}">
    <c:if test="${(not empty fileType)}">,</c:if>
    {
        fn: function(value, blockname, model) {
            var selectedFiles;
            $("#formFactoryTarget :file").each(function(idx,elt){
                if($(elt).attr('id') == blockname){
                    selectedFiles = elt.files;
                }
            });
            if(selectedFiles != undefined) {
                var currentFile = selectedFiles[0];
                var maxSize = eval('${fileSize}'.toUpperCase().replace('MB','*1024*1024').replace('KB','*1024').replace('B', '*1'));
                if(currentFile != undefined && currentFile.size > maxSize ) {
                    <c:if test="${not empty rangeMessage}">
                    return '${functions:escapeJavaScript(rangeMessage)}'
                    </c:if>
                }
            }
        }
    }
</c:if>
