<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>

<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="flowRequestContext" type="org.springframework.webflow.execution.RequestContext"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="currentForm" type="org.jahia.modules.formfactory.webflow.model.Form"--%>

<template:addResources type="css" resources="flags.css"/>
<template:addResources type="css" resources="testcssclassonform.css"/>
<template:addResources type="css" resources="jasny-bootstrap.fileinput.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="jquery-ui.min.js,jquery.blockUI.js,workInProgress.js"/>
<template:addResources type="javascript" resources="lib/underscore.js"/>
<template:addResources type="javascript" resources="lib/jasny-bootstrap.fileinput.js"/>

<fmt:message key="label.workInProgressTitle" var="i18nWaiting"/>
<c:set var="i18nWaiting" value="${functions:escapeJavaScript(i18nWaiting)}"/>

<template:addCacheDependency flushOnPathMatchingRegexp="\\\\Q${currentNode.path}\\\\E/.*"/>
<template:addResources type="inlinejavascript">
    <script>
        //Loading libraries with Jahia URLs
        var baseUrlModule = '<c:url value="${url.currentModule}"/>';
        var formJson = ${currentForm.json};
        //Loading underscore templates
        var _snippetTemplates = ${snippets.templates};
        var currentStep = ${currentForm.currentStep};
        var formName = "${currentForm.formName}";
        <c:choose>
            <c:when test="${not renderContext.editMode}">
                var formValidation = <template:include view="validationRules" templateType="js" />;
            </c:when>
            <c:otherwise>
                var formValidation = undefined;
            </c:otherwise>
        </c:choose>
        var postUrl = "${flowExecutionUrl}";
        var jsonResult = ${currentForm.jsonResults};
        var isLogged = ${renderContext.loggedIn};

        $(document).ready(function () {
            <c:choose>
                <c:when test="${not renderContext.editMode}">
                    $(document).ajaxStart($.blockUI).ajaxStop($.unblockUI);
                </c:when>
                <c:otherwise>
                    $("#formFactoryBuild").find(":input").prop("disabled",true);
                    $("#formFactoryBuild").find(".btn").hide();
                    $("#formFactoryTarget").submit(function(){return false;});
                </c:otherwise>
            </c:choose>
        });
    </script>
    <script data-main="<c:url value='${url.currentModule}/javascript/main-viewer.js'/>"
            src="<c:url value='${url.currentModule}/javascript/lib/require.js'/>"></script>
</template:addResources>

<div id="formFactoryBuild" class="row-fluid clearfix ${cssClassName}">
    <!-- Form. -->
    <c:choose>
        <c:when test="${renderContext.editMode}">
                <form id="formFactoryTarget" class="form-horizontal" action="${flowExecutionUrl}" method="post" enctype="multipart/form-data">
                    <div class="formPlaceholder">

                    </div>
                </form>
        </c:when>
        <c:otherwise>
            <template:tokenizedForm>
                <form id="formFactoryTarget" class="form-horizontal" action="${flowExecutionUrl}" method="post" novalidate enctype="application/x-www-form-urlencoded">
                    <div class="formPlaceholder">

                    </div>
                    <c:if test="${not renderContext.loggedIn and currentForm.currentStep + 1 eq currentForm.formStepsNumber}">
                        <div class="formFactoryComponent" id="captchaToMoveInForm">
                            <div class="control-group <c:if test="${fn:length(flowRequestContext.messageContext.allMessages) gt 0}"> error</c:if>">
                                <div class="controls">
                                    <template:captcha/>
                                </div>
                                <br />
                                <label class="control-label" for="captcha">
                                    <fmt:message key="fcnt_viewFormStep.label.captcha"/>
                                </label>
                                <div class="controls">
                                    <input type="text" id="captcha" name="captcha" required="required"/>
                                    <span class="<c:if test="${fn:length(flowRequestContext.messageContext.allMessages) eq 0}"> hide</c:if> help-inline">
                                    <c:forEach items="${flowRequestContext.messageContext.allMessages}" var="message">
                                        ${message.text}
                                    </c:forEach>
                                    </span>
                                </div>
                            </div>
                        </div>
                    </c:if>
                </form>
            </template:tokenizedForm>
        </c:otherwise>
    </c:choose>
</div>
<!-- / Form. -->