<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>

<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="flowRequestContext" type="org.springframework.webflow.execution.RequestContext"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>

<template:addResources type="css" resources="datepicker.css"/>
<template:addResources type="css" resources="custom.css"/>

<template:addResources type="javascript" resources="lib/bootbox.min.js"/>
<template:addResources type="javascript" resources="collections/results.js"/>
<template:addResources type="javascript" resources="main-results.js"/>

<fmt:message key="fcnt_result.username" var="usernameHeader"/>
<fmt:message key="fcnt_result.submissionDate" var="subDateHeader"/>
<fmt:message key="fcnt_result.origin" var="originHeader"/>

<template:addResources type="inlinejavascript">
    <script>
        /**
         * This function displays the result in a bootbox
         * @jsonData : The result object to display in the bootbox
         **/
        function displayData(jsonData){
            var template = "";
            _.each(jsonData.results,function(model){
                //Get Label from HtmlId
                var label = _.find(labels, function(labelObject){
                    return labelObject.htmlId == model.htmlId;
                });
                template += "<div>"+label.label+" : "+model.values.toString()+"</div>";
            });
            bootbox.dialog({
                title: '<h3><fmt:message key="fcnt_result.formData"/><h3>',
                message: template
            });
        }

        var jsVarMap = {
            dataTableNoResult: '${functions:escapeJavaScript(dataTableNoResult)}',
            usernameHeader: '${functions:escapeJavaScript(usernameHeader)}',
            subDateHeader: '${functions:escapeJavaScript(subDateHeader)}',
            originHeader: '${functions:escapeJavaScript(originHeader)}'
        };

        labels = [];
        labels.push({label: jsVarMap.usernameHeader, htmlId: 'username'}, {label: jsVarMap.subDateHeader, htmlId: 'submissionDate'}, {label: jsVarMap.originHeader, htmlId: 'origin'});
        getLabelsFromResults(labels, selectedResult);
        var resultsId = "${resultsNode.identifier}";
        moment().localeData("${currentResource.locale}");

        var resultsView;
        $(document).ready(function(){
            //Initialize datatable
            var columns = [
                {"title": jsVarMap.usernameHeader},
                {"title": jsVarMap.subDateHeader},
                {"title": jsVarMap.originHeader}
            ];
            var oDataTable = $('#formDataTable').DataTable({
                dom: "<'row-fluid'><'row-fluid'f><'row-fluid'rt><'row-fluid'i>S",
                columns: columns,
                scrollY: "400px",
                deferRender: true,
                "language": {
                    "search": "<fmt:message key='label.search'/>&nbsp;&nbsp;",
                    "info":"<fmt:message key="fcnt_result.resultsFrom"/> _START_ <fmt:message key="fcnt_result.resultsTo"/> _END_",
                    "emptyTable":"<fmt:message key="fcnt.dataTableNoResult"/>"
                }
            });

            //Creating results collection
            var results = new ResultsCollection();
            results.site = "${renderContext.site.name}";
            results.formId = selectedResult;
            results.fromDate = new Date(form.get("created")).getTime();
            results.fetch({success:function(){
                //Creating results view
                resultsView = new MetadataResultsView({
                    collection: results,
                    oDataTable: oDataTable,
                    $tableEl: $('#formDataTable')
                });
            }});
        });
    </script>
</template:addResources>

<div id="dataTable" class="row-fluid">
    <table class="table table-striped table-bordered" id="formDataTable">
        <thead>
        <tr id="dataHeaders"></tr>
        </thead>
        <tbody id="dataBody"></tbody>
    </table>
</div>
