define([
    "jquery", "underscore", "backbone",
    "collections/snippets-view", "collections/my-form-snippets-view", "views/my-form-view"
], function(
    $, _, Backbone,  SnippetsCollection, MyFormSnippetsCollection , MyFormView
) {
    return {
        initialize: function() {
            _.templateSettings = {
                interpolate: /\<\@\=(.+?)\@\>/gim,
                evaluate: /\<\@(.+?)\@\>/gim,
                escape: /\<\@\-(.+?)\@\>/gim
            };
            // Bootstrap "My Form" with 'Form Name' snippet.
            myFormView = new MyFormView({
                title: "Original",
                collection: new MyFormSnippetsCollection(formJson.formSteps[currentStep].stepContent)
            });

            // Add captcha if user is not logged
            if (!isLogged && (currentStep + 1) == formJson.formStepsNumber) {
                $(".formPlaceholder .formFactoryComponent").last().before($("#captchaToMoveInForm"));
            }
        }
    }
});
