/**
 * This function display a modal to confirm The action engaged by the user.
 */
function bbChangeSection(section) {
    if (jsVarMap.newNameIsAvailable) {
        var bbMessage;
        var bbBtnNoSave;
        var bbBtnSave;
        if (section == 'Library') {
            bbMessage = jsVarMap.modalBackToLibrary;
            bbBtnNoSave = jsVarMap.buttonBackWithoutSaving;
            bbBtnSave = jsVarMap.buttonSaveAndBack;
        } else if (section == 'Translator') {
            bbMessage = jsVarMap.modalGoToTranslator;
            bbBtnNoSave = jsVarMap.buttonGoWithoutSaving;
            bbBtnSave = jsVarMap.buttonSaveAndGo;
        } else if (section == 'Builder') {
            bbMessage = jsVarMap.modalGoToBuilder;
            bbBtnNoSave = jsVarMap.buttonGoWithoutSaving;
            bbBtnSave = jsVarMap.buttonSaveAndGo;
        }
        var $renameForm = $('#renameForm');
        if (($renameForm.val() != jsVarMap.originalName && $renameForm.val() != "")
            || ($('#cssClassName').val() != jsVarMap.originalCssClass)
            || ($('#formDescription').val() != jsVarMap.originalDescription)
            || ($('#afterSubmissionText').val() != jsVarMap.originalAfterSubmissionText)) {
            bootbox.dialog({
                title: "<h3>" + jsVarMap.titleQuitFormCenterMetaDataEditor + "<h3>",
                message: "<p>" + bbMessage + "</p>",
                buttons: {
                    danger: {
                        label: jsVarMap.labelCancel,
                        className: "btn-default",
                        callback: function () {
                        }
                    },
                    success: {
                        label: bbBtnNoSave,
                        className: "btn-danger",
                        callback: function () {
                            callWorkInProgress();
                            if (section == 'Library') {
                                backToLibraryWithoutSaving();
                            } else if (section == 'Translator') {
                                goToTranslatorWithoutSaving()
                            } else if (section == 'Builder') {
                                goToBuilderWithoutSaving();
                            }
                        }
                    },
                    main: {
                        label: bbBtnSave,
                        className: "btn-primary",
                        callback: function () {
                            callWorkInProgress();
                            if (section == 'Library') {
                                saveMetaDataAndBackToLibrary();
                            } else if (section == 'Translator') {
                                saveMetaDataAndGoToTranslator();
                            } else if (section == 'Builder') {
                                saveMetaDataAndGoToBuilder();
                            }
                        }
                    }
                }
            });
        } else {
            if (section == 'Library') {
                backToLibraryWithoutSaving();
            } else if (section == 'Translator') {
                goToTranslatorWithoutSaving()
            } else if (section == 'Builder') {
                goToBuilderWithoutSaving();
            }
        }
    } else {
        if (section == 'Library') {
            bbMessage = jsVarMap.modalBackToLibraryWithFormNewNameNotAvailable;
            bbBtnNoSave = jsVarMap.buttonBackWithoutSaving;
        } else if (section == 'Translator') {
            bbMessage = jsVarMap.modalGoToTranslatorWithFormNewNameNotAvailable;
            bbBtnNoSave = jsVarMap.buttonGoWithoutSaving;
        } else if (section == 'Builder') {
            bbMessage = jsVarMap.modalGoToBuilderWithFormNewNameNotAvailable;
            bbBtnNoSave = jsVarMap.buttonGoWithoutSaving;
        }
        bootbox.dialog({
            title: "<h3>" + jsVarMap.titleQuitFormCenterMetaDataEditor + "<h3>",
            message: "<p>" + bbMessage + "</p>",
            buttons: {
                danger: {
                    label: jsVarMap.labelCancel,
                    className: "btn-default",
                    callback: function () {
                    }
                },
                success: {
                    label: bbBtnNoSave,
                    className: "btn-danger",
                    callback: function () {
                        if (section == 'Library') {
                            backToLibraryWithoutSaving();
                        } else if (section == 'Translator') {
                            goToTranslatorWithoutSaving()
                        } else if (section == 'Builder') {
                            goToBuilderWithoutSaving();
                        }
                    }
                }
            }
        });
    }
}

/**
 * This function check if the name choose by the user is available
 */
function checkFormNameAvailableInJCR(nameForm, currentFormID) {
    // Test only if not empty
    if (nameForm != '' && jsVarMap.originalName != nameForm) {
        var errorDiv = '#error_renameFormAvailability';
        $.ajax({
            url : jsVarMap.checkFormNameURL,
            type : 'POST',
            data : { formName: nameForm, site: jsVarMap.siteName, currentFormJCRId: currentFormID },
            dataType : 'json',
            success : function(data) {
                if(data['result'] != 'success')
                {
                    jsVarMap.newNameIsAvailable = false;
                    $(errorDiv).html(data['errorMessage']);
                    $(errorDiv).show();
                    $('#btnSaveMetaData').attr("disabled", "disabled");
                    $('#btnCancelMetaData').attr("disabled", "disabled");
                }
                else{
                    jsVarMap.newNameIsAvailable = true;
                    $(errorDiv).hide();
                    $('#btnSaveMetaData').removeAttr("disabled");
                    $('#btnCancelMetaData').removeAttr("disabled");
                }
            },
            error : function(){
                jsVarMap.newNameIsAvailable = false;
                $(errorDiv).html(jsVarMap.errorFormNameImpossibleToCheck);
                $(errorDiv).show();
                $('#btnSaveMetaData').attr("disabled", "disabled");
                $('#btnCancelMetaData').attr("disabled", "disabled");
            }
        });
    }
}

/**
 * This function submit to the FlowHandler the action to save the new meta data
 */
function saveMetaData() {
    callWorkInProgress();
    $("#eventInput").attr("name", "_eventId_saveMetaData");
    $("#currentFormMetaData").submit();
}

/**
 * This function submit to the FlowHandler the action to save the current
 * modification and go to the builder
 */
function saveMetaDataAndBackToLibrary() {
    callWorkInProgress();
    $("#eventInput").attr("name", "_eventId_saveMetaDataAndBackToLibrary");
    $("#currentFormMetaData").submit();
}

/**
 * This function submit to the FlowHandler the action to save the current
 * modification and go to the translator
 */
function saveMetaDataAndGoToTranslator() {
    callWorkInProgress();
    $("#eventInput").attr("name", "_eventId_saveMetaDataAndGoToTranslator");
    $("#currentFormMetaData").submit();
}

/**
 * This function submit to the FlowHandler the action to save the current
 * modification and go to the builder
 */
function saveMetaDataAndGoToBuilder() {
    callWorkInProgress();
    $("#eventInput").attr("name", "_eventId_saveMetaDataAndGoToBuilder");
    $("#currentFormMetaData").submit();
}

/**
 * This function submit to the FlowHandler the action to back to the library
 * without saving the current modification
 */
function backToLibraryWithoutSaving() {
    callWorkInProgress();
    $("#eventInput").attr("name", "_eventId_backToLibraryWithoutSaving");
    $("#currentFormMetaData").submit();
}

/**
 * This function submit to the FlowHandler the action to go to the builder
 * without saving the current modification
 */
function goToBuilderWithoutSaving() {
    callWorkInProgress();
    $("#eventInput").attr("name", "_eventId_goToBuilderWithoutSaving");
    $("#currentFormMetaData").submit();
}

/**
 * This function submit to the FlowHandler the action to go to the Translator
 * without saving the current modification
 */
function goToTranslatorWithoutSaving() {
    callWorkInProgress();
    $("#eventInput").attr("name", "_eventId_goToTranslatorWithoutSaving");
    $("#currentFormMetaData").submit();
}

function addNewLanguages() {
    callWorkInProgress();
    $("#currentFormTranslationEventInput").attr("name", "_eventId_addNewLanguages");
    $("#currentFormTranslation").submit();
}

function callWorkInProgress() {
    if($.browser.msie == true){
        $.blockUI({ css: {
            border: 'none',
            padding: '15px',
            backgroundColor: '#000',
            '-webkit-border-radius': '10px',
            '-moz-border-radius': '10px',
            opacity: .5,
            color: '#fff'
        }, message: jsVarMap.i18nWaiting });
    } else {
        workInProgress(jsVarMap.i18nWaiting);
    }
}

function toggleMetaDataButton() {
    var $renameForm = $('#renameForm');
    var $cssClassName = $('#cssClassName');
    if (($renameForm.val() != jsVarMap.originalName && $renameForm.val() != "")
        || ($cssClassName.val() != jsVarMap.originalCssClass && ($cssClassName.val().match(/^[a-zA-Z0-9_.-]*$/)))
        || ($('#formDescription').val() != jsVarMap.originalDescription)
        || ($('#afterSubmissionText').val() != jsVarMap.originalAfterSubmissionText)) {
        $('#btnSaveMetaData').removeAttr("disabled");
        $('#btnCancelMetaData').removeAttr("disabled");
    } else {
        $('#btnSaveMetaData').attr("disabled", "disabled");
        $('#btnCancelMetaData').attr("disabled", "disabled");
    }

    if($cssClassName.val().match(/^[a-zA-Z0-9_-]*$/)) {
        $('#error_cssClass').hide();
    } else {
        $('#error_cssClass').show();
    }
}

function toggleTranslationButton() {
    if ($('#formTranslation').val() != null) {
        $('#btnSaveTranslation').removeAttr("disabled");
        $('#btnCancelTranslation').removeAttr("disabled");
    } else {
        $('#btnSaveTranslation').attr("disabled", "disabled");
        $('#btnCancelTranslation').attr("disabled", "disabled");
    }
}

function resetMetaData() {
    bootbox.dialog({
        title: "<h3>" + jsVarMap.titleConfirmCancelLastChanges + "<h3>",
        message: "<p>" + jsVarMap.modalCancelModification + "</p>",
        buttons: {
            danger: {
                label: jsVarMap.labelCancel,
                className: "btn-default",
                callback: function () {
                }
            },
            success: {
                label: jsVarMap.labelOK,
                className: "btn-danger",
                callback: function () {
                    $('#renameForm').val(jsVarMap.originalName);
                    $('#cssClassName').val(jsVarMap.originalCssClass);
                    $('#formDescription').val(jsVarMap.originalDescription);
                    $('#afterSubmissionText').val(jsVarMap.originalAfterSubmissionText);
                    toggleMetaDataButton();
                }
            }
        }
    });
}

function resetTranslation() {
    $('#formTranslation').val("");
    toggleTranslationButton();
}