/**
 * Created by dgaillard on 11/09/14.
 */

/**
 * This function get the list of labels basing on the element with the highest number of values
 * @results : The list of results
 */
function getLabelsFromResults(labels, formId) {
    $.ajax({
        type: "GET",
        async: false,
        url:getFetchURL({formId:formId,apiMethodName:"results_label"}),
        success:function(result) {
            _.each(result.data,function(label, index){
                labels.push({"label":label, htmlId:index});
            });
        }
    });
}

/**
 * This function set the collection date range and refetch it
 */
function filterResults() {
    var $datePicker = $("#datePicker");
    if ($datePicker.find("input[name=from]").val() != "") {
        dataCollection.fromDate = new Date(moment($datePicker.find("input[name=from]").val(), "DD/MM/YYYY")).getTime();
    }
    if ($datePicker.find("input[name=to]").val() != "") {
        dataCollection.toDate = new Date(moment($datePicker.find("input[name=to]").val(), "DD/MM/YYYY")).getTime();
    }
    dataCollection.reset();
    dataCollection.resetted = true;
    dataCollection.getFirstPage();
    return false;
}

/**
 * This function change dashboard model fromDate and toDate attribute
 * @param model : the dashboard model
 */
function filterGraphResults(model){
    //FromDate
    var $datePicker = $("#datePicker");
    if ($datePicker.find("input[name=from]").val() != "") {
        model.fromDate = new Date(moment($datePicker.find("input[name=from]").val(), "DD/MM/YYYY")).getTime();
    }
    else{
        model.fromDate = null;
    }

    //Todate
    if($datePicker.find("input[name=to]").val() != ""){
        model.toDate =new Date(moment($datePicker.find("input[name=to]").val(), "DD/MM/YYYY")).getTime();
    }
    else{
        model.toDate = null;
    }
    model.trigger("change");
}

/**
 * This function hide or show a column of the datatable
 * @iCol : column index
 */
function fnShowHide(iCol) {
    /* Get the DataTables object again,
       this is not a recreation,
       just a get of the object */
    var oTable = $('#formDataTable').DataTable();
    // Get the column API object
    var column = oTable.column( iCol );
    // Toggle the visibility
    column.visible( ! column.visible() );
}

/**
 * This function create the checkboxes
 * @param labels
 */
function addCheckboxesInPicker(labels) {

    //Remove existing fields pickers
    $(".checkboxRemover").remove();
    $(".columnPickerRow").remove();
    $("#columnschoice").empty();
    var columnPickerRow = 1;
    _.each(labels, function(labelObject, key) {
        if (key % 6 == 0) {
            columnPickerRow++;
            $("#columnschoice").append("<div id='columnPickerRow" + columnPickerRow + "' class='controls controls-row columnPickerRow'></div>")
        }
        var isChecked = (key <= 4);
        $("#columnPickerRow" + columnPickerRow).append(_checkboxesTemplate({label: labelObject.label, htmlId: labelObject.htmlId, key:key, isChecked: isChecked}));
    });
}

/**
 * This function is used in the results view to fill the actionsViews Table with an ajax call
 * (Table that list all applicable views by actions)
 * @param formUuid : Id of the form that contains the actions (to append to the Ajax call URL)
 * @param ApiUrlBase : Ajax call URL Base
 * @param locale : locale (to append to the Ajax call URL)
 */
function fillActionViews(formUuid, ApiUrlBase, locale){
    var url = ApiUrlBase + "/" + locale + "/" + formUuid+"/views";
    $.ajax({
        url : url,
        type : 'GET',
        dataType : 'json',
        async:false,
        success : function(viewsResult) {
            actionsViews = viewsResult.data;
        }
    });
}

/**
 * This function is used in the results views to fill the views select list
 * @param resultFormId : Id of the selected Form
 * @param selectedView : Id of the selected view
 * @param formSelected : Boolean to know if a form has been selected
 */
function fillviewSelect(resultFormId, selectedView, formSelected){
    if(formSelected){
        var selectField = $("#formViewInput");
        form = formsView.collection.find(function(model){
            return model.get("resultFormId") == resultFormId
        });
        if(_.size(form)){
            _.each(form.get("actions"),function(action){
                _.each(actionsViews[action],function(viewBundle,viewId){
                    var option = $("<option>",{value:viewId, actionId:actionsProviders[action]});
                    option.html(viewBundle);
                    if(viewId == selectedView){
                        option.attr("selected","selected");
                    }
                    selectField.append(option);
                });
            });
        }
    }
}

/**
 * This function is used in the fcnt_results.results.jsp file to submit the selected form and view
 * @param formId : Id of the selected form
 */
function submitForm(formId){
    var form = $("#"+formId);
    form.find("#formInput").val(formId);
    form.find("#actionInput").val($('option:selected', form.find("select[name='view']")).attr('actionid'));
    form.find("#actionview").val($('option:selected', form.find("select[name=view]")).val().split(".")[0]+"URL");
    form.submit();
}

/**
 * This function is used in the Results views to submit a view (navigate to another view than the one currently displayed)
 */
function submitView(){
    $("form[name='select-view-from']").submit();
}
/**
 * This function is used in the results view to submit an empty form which will have the effect of returning to the first result page
 */
function reinitForm(){
    $(".form-input").val("");
    $("form[name='select-view-from']").submit();
}

function setTimeParameter(model,object){
    var timeValue = object.val();
    var legendLabel = object.attr("legend-label");
    var parameters = model.parameters;
    var groupParam = _.find(parameters,function(parameter){
        return parameter.name=="group_by";
    });
    if(groupParam.values.length>1){
        groupParam.values[1]=timeValue;
    }else{
        groupParam.values[0]=timeValue;
    }
    model.parameters = parameters;
    model.renderData();
};