function callWorkInProgress() {
    if( $.browser.msie == true){
        $.blockUI({ css: {
            border: 'none',
            padding: '15px',
            backgroundColor: '#000',
            '-webkit-border-radius': '10px',
            '-moz-border-radius': '10px',
            opacity: .5,
            color: '#fff'
        }, message: jsVarMap.i18nWaiting });
    } else {
        workInProgress(jsVarMap.i18nWaiting);
    }
}

/**
 * This function display a modal to confirm The action engaged by the user.
 */
function bbChangeSection(section) {
    if(blockInfoPopupOnSectionChange) {
        if (section == 'Library') {
            backToLibraryWithoutSaving();
        } else {
            $("#eventInput").attr("name", "_eventId_goToMetaDataEditorWithoutSaving");
            $("#currentForm").submit();
        }
        return;
    }
    var bbMessage;
    var bbBtnNoSave;
    var bbBtnSave;
    if (section == 'Library') {
        bbMessage = jsVarMap.modalBackToLibrary;
        bbBtnNoSave = jsVarMap.buttonBackWithoutSaving;
        bbBtnSave = jsVarMap.buttonSaveAndBack;
    } else {
        bbMessage = jsVarMap.modalGoToMetaDataEditor;
        bbBtnNoSave = jsVarMap.buttonGoWithoutSaving;
        bbBtnSave = jsVarMap.buttonSaveAndGo;
    }
    bootbox.dialog({
        title: "<h3>" + jsVarMap.titleQuitFormCenterTranslator + "<h3>",
        message: "<p>" + bbMessage + "</p>",
        buttons: {
            danger: {
                label: jsVarMap.labelCancel,
                className: "btn-default",
                callback: function() {}
            },
            success: {
                label: bbBtnNoSave,
                className: "btn-danger",
                callback: function() {
                    callWorkInProgress();
                    if (section == 'Library') {
                        backToLibraryWithoutSaving();
                    } else {
                        $("#eventInput").attr("name", "_eventId_goToMetaDataEditorWithoutSaving");
                        $("#currentForm").submit();
                    }
                }
            },
            main: {
                label: bbBtnSave,
                className: "btn-primary",
                callback: function() {
                    saveForm();
                    callWorkInProgress();
                    if (section == 'Library') {
                        // Setting the good Webflow event
                        $("#eventInput").attr("name", "_eventId_saveAndBackToLibrary");
                        $("#currentForm").submit();
                    } else {
                        // Setting the good Webflow event
                        $("#eventInput").attr("name", "_eventId_saveAndGoToMetaDataEditor");
                        $("#currentForm").submit();
                    }
                }
            }
        }
    });
}

/**
 * This function save the form and submit to the FlowHandler if valid return true
 */
function submitTranslation() {
    saveForm();
    callWorkInProgress();
    if (currentStep == "stepAction") {
        $("#currentStep").val(0);
    } else {
        $("#currentStep").val(currentStep);
    }
    // Setting the good Webflow event
    $("#eventInput").attr("name", "_eventId_saveFormTranslation");
    $("#currentForm").submit();
}

/**
 * This function submit to the FlowHandler the action to back to the library
 * without saving the current modification
 */
function backToLibraryWithoutSaving() {
    callWorkInProgress();
    $("#eventInput").attr("name", "_eventId_backToLibraryWithoutSaving");
    $("#currentForm").submit();
}

/**
 * This function save the current step and the form in the variable formJson
 */
function saveForm() {
    // Saving the current Form in stepsTable
    if (currentStep == "stepAction") {
        stepAction.stepActionContent = formView.collection.toJSON();
        formJson.formStepAction = stepAction;
    } else {
        stepsTable[currentStep].stepContent = formView.collection.toJSON();
        formJson.formSteps = stepsTable;
        formJson.formStepsNumber = stepsTable.length;
    }
    // Converting to Json String
    var jsonString = JSON.stringify(formJson);
    $("#formNewJson").val(jsonString);
}

/**
 * This function clone the form in the new displayed step
 * @param newStep : the last step activate by the user
 */
function saveAndLoadFormInSteps (newStep) {
    var oldStep = currentStep;

    // Saving the current Form in stepsTable
    if (currentStep == "stepAction") {
        stepAction.stepActionContent = formView.collection.toJSON();
    } else {
        stepsTable[oldStep].stepContent = formView.collection.toJSON();
    }

    // Changing current Step
    currentStep = newStep;

    // Loading the form step in the form view
    formView.collection.reset();
    if (currentStep == "stepAction") {
        if (stepAction.stepActionContent.length > 0) {
            formView.collection.add(stepAction.stepActionContent);
        } else {
            formView.collection.cleanView();
        }
        $("#step" + oldStep + "Content").attr("id", "stepActionContent");
    } else {
        if (stepsTable[currentStep].stepContent.length > 0) {
            formView.collection.add(stepsTable[currentStep].stepContent);
        }
        else {
            formView.collection.cleanView();
        }
        // Updating tabContent Id to Match
        $("#step" + oldStep + "Content").attr("id", "step" + currentStep + "Content");
    }
}