define([
    "jquery", "underscore", "backbone",
    "views/snippet", "views/temp-snippet",
    "helper/pubsub"
], function ($, _, Backbone, SnippetView, TempSnippetView, PubSub) {
    return SnippetView.extend({
        events: {
            "click": "preventPropagation", //stops checkbox / radio reacting.
            "mousedown": "mouseDownHandler",
            "mouseup": "mouseUpHandler"
        },
        mouseDownHandler: function (mouseDownEvent) {
            function displayArrow() {
                var accordionValidations = $("#accordionValidations");
                accordionValidations.find(".icon-ok").hide();
                accordionValidations.find(".order-arrow").hide();
                var activeValidationsList = accordionValidations.find("input:checked");
                activeValidationsList.parents(".accordion-group").find(".icon-ok").show();
                activeValidationsList.parents(".accordion-group").find(".order-arrow").show();
                activeValidationsList.parents(".accordion-group").find(".order-arrow").css("margin", "0px");
                activeValidationsList.last().parents(".accordion-group").find(".icon-arrow-down").hide();
                activeValidationsList.last().parents(".accordion-group").find(".icon-arrow-up").css("margin-left", "17px");
                activeValidationsList.first().parents(".accordion-group").find(".icon-arrow-up").hide();
                activeValidationsList.first().parents(".accordion-group").find(".icon-arrow-down").css("margin-right", "17px");
            }

            mouseDownEvent.stopPropagation();
            mouseDownEvent.preventDefault();
            var that = this;
            //popover
            $(".popover").remove();
            this.$el.popover("show");
            var accordionValidations = $("#accordionValidations");
            accordionValidations.find(".icon-ok").hide();
            accordionValidations.find(".order-arrow").hide();
            if (accordionValidations.find("input:checked").attr("id") != undefined && accordionValidations.find("input:checked").attr("id").match("activator$")) {
                displayArrow();
            }
            $(".popover .activator").on("click", function (e) {
                var $accordionValidations = $("#accordionValidations");
                var activeValidationsList = $accordionValidations.find("input:checked");
                var order = _.size(activeValidationsList);
                var accordionGroupTarget = $("#accordionValidations_" + e.currentTarget.id.split("_")[0]);
                if (e.currentTarget.checked) {
                    if (order == 1) {
                        accordionGroupTarget.data("order", (order - 1));
                        accordionGroupTarget.attr("data-order", (order - 1));
                        $("#" + accordionGroupTarget.data('idacc') + "_ordernumber").val((order - 1));
                        accordionGroupTarget.insertBefore($accordionValidations.find(".accordion-group").first());
                    } else {
                        accordionGroupTarget.data("order", (order - 1));
                        accordionGroupTarget.attr("data-order", (order - 1));
                        $("#" + accordionGroupTarget.data('idacc') + "_ordernumber").val((order - 1));
                        accordionGroupTarget.insertAfter(activeValidationsList.eq(-2).parents(".accordion-group"));
                    }
                } else {
                    accordionGroupTarget.data("order", 999);
                    accordionGroupTarget.attr("data-order", 999);
                    $("#" + accordionGroupTarget.data('idacc') + "_ordernumber").val(999);
                    accordionGroupTarget.insertAfter(activeValidationsList.last().parents(".accordion-group"));
                    $.each(activeValidationsList, function (k, v) {
                        $(v).parents(".accordion-group").data("order", k);
                        $(v).parents(".accordion-group").attr("data-order", k);
                        $("#" + $(v).parents(".accordion-group").data('idacc') + "_ordernumber").val(k);
                    });
                }
                displayArrow();
            });
            $("#formFactoryBuild").trigger("popover_show", { event: mouseDownEvent } );

            accordionValidations.find(".icon-arrow-up").on("click", function (mouseClickEvent) {
                var elmnt = $(mouseClickEvent.currentTarget);
                var accordionGroupTarget = $("#accordionValidations_" + elmnt.data('idacc'));
                var order = parseInt(accordionGroupTarget.data("order"));
                var upperElmnt = $("#accordionValidations").find(".accordion-group[data-order='" + (parseInt(order) - 1) + "']");
                upperElmnt.insertAfter(accordionGroupTarget);
                accordionGroupTarget.data("order", (order - 1));
                accordionGroupTarget.attr("data-order", (order - 1));
                upperElmnt.data("order", order);
                upperElmnt.attr("data-order", order);
                $("#" + upperElmnt.data('idacc') + "_ordernumber").val(order);
                $("#" + elmnt.data('idacc') + "_ordernumber").val((order - 1));
                displayArrow();
            });
            accordionValidations.find(".icon-arrow-down").on("click", function (mouseClickEvent) {
                var elmnt = $(mouseClickEvent.currentTarget);
                var accordionGroupTarget = $("#accordionValidations_" + elmnt.data('idacc'));
                var order = parseInt(accordionGroupTarget.data("order"));
                var lowerElmnt = $("#accordionValidations").find(".accordion-group[data-order='" + (parseInt(order) + 1) + "']");
                accordionGroupTarget.insertAfter(lowerElmnt);
                accordionGroupTarget.data("order", (order + 1));
                accordionGroupTarget.attr("data-order", (order + 1));
                lowerElmnt.data("order", order);
                lowerElmnt.attr("data-order", order);
                $("#" + lowerElmnt.data('idacc') + "_ordernumber").val(order);
                $("#" + elmnt.data('idacc') + "_ordernumber").val((order + 1));
                displayArrow();
            });
            $('.popover #save').on("click", this.saveHandler(that));
            $('.popover #cancel').on("click", this.cancelHandler(that));
            //Add an option row to the input
            $("#optionsPlusButton").on("click", function () {
                if (that.optionNumber === undefined) {
                    //Initialize optionNUmber
                    that.optionNumber = $(".optionRow").length
                }
                else {
                    //Increment optionNumber
                    that.optionNumber++;
                }

                var row_template = '<div id="row-<@=optionNumber@>" class="optionRow">' +
                    '<div class="span4">' +
                    '<input id="key-<@=optionNumber@>" class="input-small keyField" type="text" value="" name="key-<@=optionNumber@>" data-type="key"/>' +
                    '</div>' +
                    '<div class="span5">' +
                    '<input id="value-<@=optionNumber@>" class="input-small" type="text" value="" name="value-<@=optionNumber@>" data-type="value"/>' +
                    '</div>' +
                    '<div class="span3">' +
                    '<input id="checked-<@=optionNumber@>" class="input-small" type="checkbox" name="checked-<@=optionNumber@>" data-type="checked"/>' +
                    '<button id="remove-<@=optionNumber@>" class="removeButton btn btn-mini btn-link" type="button" onclick="$(\'#row-<@=optionNumber@>\').remove()"><i class="icon-minus-sign"></i></button>' +
                    '</div>' +
                    '</div>';
                var rowNumber = {optionNumber: that.optionNumber};
                var compiledTemplate = _.template(row_template);
                $(".optionRows").append(compiledTemplate(rowNumber));
            });
            //Listen to remove button click to remove key-value couple
            $(".removeButton").on("click", function (mouseClickEvent) {
                var buttonElement = mouseClickEvent.currentTarget;
                //get the row number from button
                var rowNumber = $(buttonElement).attr("rownumber");
                //Remove the row
                $("#row-" + rowNumber).remove();
            });
            //add drag event for all
            if (this.model.get("title") !== "Single Button" && this.model.get("title") !== "Triple Button") {
                $("body").on("mousemove", function (mouseMoveEvent) {
                    if (
                        Math.abs(mouseDownEvent.pageX - mouseMoveEvent.pageX) > 10 ||
                        Math.abs(mouseDownEvent.pageY - mouseMoveEvent.pageY) > 10
                        ) {
                        that.$el.popover('destroy');
                        PubSub.trigger("mySnippetDrag", mouseDownEvent, that.model);
                        that.mouseUpHandler();
                    }
                });
            }
        },
        preventPropagation: function (e) {
            e.stopPropagation();
            e.preventDefault();
        },
        mouseUpHandler: function () {
            $("body").off("mousemove");
        },
        saveHandler: function (boundContext) {
            function saveFields(fields) {
                _.each(fields, function (e) {
                    var $e = $(e),
                        type = $e.attr("data-type"),
                        name = $e.attr("id");
                    switch (type) {
                        case "checkbox":
                            boundContext.model.setField(name, $e.is(":checked"));
                            break;
                        case "input":
                            boundContext.model.setField(name, $e.val());
                            break;
                        case "hidden":
                            boundContext.model.setField(name, $e.val());
                            break;
                        case "textarea":
                            boundContext.model.setField(name, $e.val());
                            break;
                        case "textarea-split":
                            boundContext.model.setField(name,
                                _.chain($e.val().split("\n"))
                                    .map(function (t) {
                                        return $.trim(t)
                                    })
                                    .filter(function (t) {
                                        return t.length > 0
                                    })
                                    .value()
                            );
                            break;
                        case "select":
                            var valarr = _.map($e.find("option"), function (e) {
                                return {
                                    value: e.value,
                                    selected: e.selected,
                                    label: $(e).text()
                                };
                            });
                            boundContext.model.setField(name, valarr);
                            break;
                        case "key-value":
                            keyValues = [];
                            _.each($e.find(".keyField"), function (keyInput) {
                                var $key = $(keyInput);
                                var valueId = $key.attr("id").replace("key", "value");
                                var $value = $("#" + valueId);
                                var checked = false;
                                if($("#"+$key.attr("id").replace("key", "checked")).is(':checked')) {
                                    checked = true;
                                }
                                keyValues.push({"key": $key.val(), "value": $value.val(), "checked":checked});
                            });
                            boundContext.model.setField(name, keyValues);
                            break;
                    }
                });
                boundContext.optionNumber = undefined;
            }

            function saveValidations(fields) {
                _.each(fields, function (e) {
                    var $e = $(e),
                        type = $e.attr("data-type"),
                        fieldID = $e.attr("id"),
                        validationFieldName = fieldID.split("_")[1];

                    if (validationFieldName == "activator") {
                        if ($e.is(":checked")) {
                            boundContext.model.setValidation(fieldID, $e.is(":checked"));

                            var validationName = fieldID.split("_")[0];

                            _.each(fields, function (e) {
                                var $e = $(e),
                                    type = $e.attr("data-type"),
                                    fieldID = $e.attr("id");

                                if (fieldID.split("_")[0] == validationName) {
                                    if (fieldID.split("_")[1] != "activator") {
                                        switch (type) {
                                            case "checkbox":
                                                boundContext.model.setValidation(fieldID, $e.is(":checked"));
                                                break;
                                            case "input":
                                                boundContext.model.setValidation(fieldID, $e.val());
                                                break;
                                            case "hidden":
                                                boundContext.model.setValidation(fieldID, $e.val());
                                                break;
                                            case "textarea":
                                                boundContext.model.setValidation(fieldID, $e.val());
                                                break;
                                            case "textarea-split":
                                                boundContext.model.setValidation(fieldID,
                                                    _.chain($e.val().split("\n"))
                                                        .map(function (t) {
                                                            return $.trim(t)
                                                        })
                                                        .filter(function (t) {
                                                            return t.length > 0
                                                        })
                                                        .value()
                                                );
                                                break;
                                            case "select":
                                                var valarr = _.map($e.find("option"), function (e) {
                                                    return {
                                                        value: e.value,
                                                        selected: e.selected,
                                                        label: $(e).text()
                                                    };
                                                });
                                                boundContext.model.setValidation(fieldID, valarr);
                                                break;
                                        }
                                    }
                                }
                            });
                        } else {
                            boundContext.model.unsetValidation(fieldID);
                        }
                    }
                });
            }

            function checkDoubleIDInCurrentStep() {
                var arrayID = [];
                if (currentStep == "stepAction") {
                    stepAction.stepActionContent = formView.collection.toJSON();
                    for (snippet in stepAction.stepActionContent) {
                        arrayID.push(stepAction.stepActionContent[snippet].fields.id.value);
                    }
                } else {
                    stepsTable[currentStep].stepContent = formView.collection.toJSON();
                    for (snippet in stepsTable[currentStep].stepContent) {
                        arrayID.push(stepsTable[currentStep].stepContent[snippet].fields.id.value);
                    }
                }

                var sorted_arr = arrayID.sort();
                var results = [];
                for (var i = 0; i < arrayID.length - 1; i++) {
                    if (sorted_arr[i + 1] == sorted_arr[i]) {
                        results.push(sorted_arr[i]);
                    }
                }
                return results.length;
            }

            /**
             * Searches through the fields for any key-value fields, validates that any keys found are not empty.
             * @param fields fields contained in the current popup
             * @returns {boolean}
             */
            function checkEmptyKeyValuePair(fields) {
                var isEmptyKey = false;
                _.each(fields, function (e) {
                    var $e = $(e),
                        type = $e.attr("data-type");
                    switch (type) {
                        case "key-value":
                            _.each($e.find(".keyField"), function (keyInput) {
                                if(_.isEmpty($(keyInput).val().trim())){
                                    isEmptyKey = true;
                                }
                            });
                            break;
                    }
                });
                return isEmptyKey;
            }

            return function (mouseEvent) {
                mouseEvent.preventDefault();
                var fields = $("#structure").find(".field");
                if (checkEmptyKeyValuePair(fields)) {
                    var $errorId = $('#error_keyValue');
                    $errorId.html(jsVarMap.errorEmptyKey);
                    $errorId.show();
                    return false;
                }
                saveFields(fields);
                fields = $("#validation").find(".field");
                saveValidations(fields);
                if (checkDoubleIDInCurrentStep() > 0) {
                    var $errorId = $('#error_id');
                    $errorId.html(jsVarMap.errorDoubleIDInStep);
                    $errorId.show();
                    return false;
                }
                boundContext.model.trigger("change");
                $(".popover").remove();
            }
        },
        cancelHandler: function (boundContext) {
            return function (mouseEvent) {
                mouseEvent.preventDefault();
                $(".popover").remove();
                boundContext.model.trigger("change");
                boundContext.optionNumber = undefined;
            }
        }

    });
});