define([
    "jquery", "underscore", "backbone"
    , "models/snippet"
    , "views/snippet", "views/temp-snippet"
    , "helper/pubsub"
], function ($, _, Backbone, SnippetModel, SnippetView, TempSnippetView, PubSub) {
    return SnippetView.extend({
        events: {
            "mousedown": "mouseDownHandler"
        }, mouseDownHandler: function (mouseDownEvent) {
            mouseDownEvent.preventDefault();
            mouseDownEvent.stopPropagation();
            //hide all popovers
            $(".popover").hide();
            var snippetModel = new SnippetModel();
            snippetModel.clear();
            var number = formView.collection.size();
            snippetModel.set(JSON.parse(JSON.stringify(this.model.attributes)));
            snippetModel.setField("id",snippetModel.get("fields").id.value+'_'+currentStep+'_'+number);
            $("body").append(new TempSnippetView({model: snippetModel}).render());
            PubSub.trigger("newTempPostRender", mouseDownEvent);
        }
    });
});
