define([
    'jquery', 'underscore', 'backbone'
    , "text!templates/app/tab-nav.html"

], function ($, _, Backbone, _tabNavTemplate) {
    return Backbone.View.extend({
        tagName: "div", className: "tab-pane", initialize: function (options) {
            this.title = options.title;
            this.id = this.title.toLowerCase().replace(/\W/g, '');
            this.tabNavTemplate = _.template(_tabNavTemplate);
            this.render();
        }, render: function () {
            // Render Snippet Views
            var that = _.clone(this);
            if (that.collection !== undefined) {
                that.collection.models = _.sortBy(that.collection.models, function(snippet){return snippet.attributes.title});
                _.each(that.collection.renderAll(), function (snippet) {
                    that.$el.append(snippet);
                });
            } else if (that.content) {
                that.$el.append(that.content);
            }
            // Render & append nav for tab
            $("#formFactoryComponentsTabs").append(this.tabNavTemplate({title: this.title, id: this.id}));
            // Render tab
            this.$el.attr("id", this.id);
            this.$el.appendTo("#components-tab-content");
            this.delegateEvents();
        }
    });
});
